#include <windows.h>
#include "base.h"

/*  Declara el procedimiento Windows  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

/*  El nombre de la clase es una variable global  */
char szClassName[ ] = "BaseWindowsApp";

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* Handle de la ventana */
    MSG messages;            /* Para guardar los mensajes a la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase ventana */

    static TCHAR szAppName[] = TEXT("Aplicacin Base");
    static TCHAR szClassName[] = TEXT("Base");

    /* Estructura ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /*Funcin llamada por windows */
    wincl.style = CS_DBLCLKS;                 /* detecta doble clic */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* iconos predeterminados */
    wincl.hIcon = LoadIcon (NULL, MAKEINTRESOURCE(IDI_BASE));
    wincl.hIconSm = LoadIcon (NULL, MAKEINTRESOURCE(IDI_BASESM));
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* Sin men */
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    /* color de fondo predeterminado para el fondo */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Registra la clase ventana, si no puede termina el programa */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* Clase registrada: se crea el programa */
    hwnd = CreateWindowEx (
           0,                   /* Estilo extendido */
           szClassName,         /* Nombre de la clase */
           szAppName,           /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* ventana predeterminada */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* en la pantalla */
           544,                 /* ancho y altura en pxeles */
           375,
           HWND_DESKTOP,        /* La ventana es una ventana hija del escritorio */
           NULL,                /* Handle al men */
           hThisInstance,       /* Handle a la instancia del programa */
           NULL                 /* Puntero a los datos de creacin de la ventana*/
           );

    /* Hace que la ventana sea visible en la pantalla */
    ShowWindow (hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes que se ejecuta hasta que GetMessage() devuelva 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Traduce mensajes virtual-key a caracteres */
        TranslateMessage(&messages);
        /* Enva el mensaje a WindowProcedure */
        DispatchMessage(&messages);
    }

    /* El valor de retorno del programa es 0 - El valor dado por PostQuitMessage() */
    return messages.wParam;
}


/* La funcin Windows  DispatchMessage() llama a esta funcin */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HDC hDC;
	PAINTSTRUCT ps;
	RECT rect;
    switch (message)                  /* gestin de los mensajes */
    {
        case WM_PAINT:
			hDC = BeginPaint(hwnd, &ps);
			GetClientRect(hwnd, &rect);
			DrawText(hDC, TEXT("Programacin Base funciona"), -1, &rect,
					DT_SINGLELINE |DT_CENTER | DT_CENTER);
			EndPaint(hwnd, &ps);
			break;
        case WM_DESTROY:
            PostQuitMessage (0);       /* enva un mensaje WM_QUIT a la cola */
            break;
        default:                      /* para el resto de los mensajes */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

