//-----------------------------------------------------------------
// Archivo de cdigo C++ - Caracol.cpp
//-----------------------------------------------------------------
//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "Blitzkrieg.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("Blitkrieg"), TEXT("Blitzkrieg"),
    IDI_BLITZKRIEG, IDI_BLITZKRIEG_SM,
    780, 580, 20); // frecuencia 20 fps equivale a 1 ciclo cada 50 milisegundos

  // si no se pudo crear el objeto juego
  // no se inicia
  if (g_pJuego == NULL)
    return false;

  // Se inicializa el joystick
  if (!g_pJuego->InicializarJoystick())
    return false;

  return true;
}
void FJ_ComenzarJuego(HWND hWindow)
{

  // Obtiene un handle al contexto de dispositivo
  HDC hDC = GetDC(hWindow);

  // Crea una serie de mapa de bits
  // Los mapas de bits son de profundidad 24 bits

  // El objeto impacto se mostrar cada vez que
  // se produzca una colisin
  g_pImpactoBomba = new cBMP(hDC, TEXT("Recursos//impactoBomba.bmp"));
  g_pImpactoMisil = new cBMP(hDC, TEXT("Recursos//impactoMisil.bmp"));
  // Si hay un impacto al can se muestra otro
  // mapa de bits
  g_pCanonEnLlamas = new cBMP(hDC, TEXT("Recursos//CanonEnLlamas.bmp"));

  // Fondo del juego
  g_pFondoJuego = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());
  // Los dos tipos de aviones
  // uno para el que va hacia la derecha
  // y el otro el que va hacia la izquierda

  g_pAvion[0] = new cBMP(hDC, TEXT("Recursos//avion0.bmp"));
  g_pAvion[1] = new cBMP(hDC, TEXT("Recursos//avion1.bmp"));

  // Bitmap de la bomba que arroja cada avin
  g_pBomba = new cBMP(hDC, TEXT("Recursos//bomba.bmp"));

  // Bitmap de los misiles tierra - aire
  g_pMisil = new cBMP(hDC, TEXT("Recursos//misil.bmp"));

  // Bitmap del lanzador de misiles tierra - aire
  g_pCanon = new cBMP(hDC, TEXT("Recursos//canon.bmp"));

  // Una nube que pasa por el cielo
  g_pNube = new cBMP(hDC, TEXT("Recursos//nubes.bmp"));

  // Inicializar los contadores del juego
  FJ_NuevoJuego();

  // Bfer auxiliar de repintado
  // Crea un contexto de dispositivo y un
  // mapa de bits adicional
  g_hBuferAuxDC = CreateCompatibleDC(hDC);
  g_hBuferAuxBitmap = CreateCompatibleBitmap(hDC,
      g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura());
  SelectObject(g_hBuferAuxDC , g_hBuferAuxBitmap);

 }
void FJ_FinalizarJuego()
{
  // Elimina los elementos del bfer auxiliar
  DeleteObject(g_hBuferAuxBitmap);
  DeleteObject(g_hBuferAuxDC);

  // Elimina objetos bmp
  delete g_pAvion[0];
  delete g_pAvion[1];
  delete g_pBomba;
  delete g_pCanon;
  delete g_pMisil;
  delete g_pNube;

  // Bitmap de impacto
  delete g_pImpactoBomba;
  delete g_pImpactoMisil;
  delete g_pCanonEnLlamas;

  // Limpieza del vector de sprites
  g_pJuego->LimpiarVector();

  // elimina el mapa de bits de fondo
  delete g_pFondoJuego;

  // Elimina el objeto
  delete g_pJuego;

  // Cierra el dispositivo
  g_pJuego->MIDI(CERRARMIDI);
}
void FJ_ReactivarJuego(HWND hWindow)
{
    // Capturar el joystick
    g_pJuego->CapturarJoystick();

    // reactiva la msica de fondo
    // con la msica que se estaba
    // reproduciendo en el momento
    // de la pausa
    g_pJuego->MIDI(PLAYMIDI,NULL,false);
}
void FJ_DetenerJuego(HWND hWindow)
{
    // Liberar el joystick
     g_pJuego->LiberarJoystick();

    // Suspende la msica de fondo
    g_pJuego->MIDI(PAUSARMIDI);
}
void FJ_PintarJuego(HDC hDC)
{

    POINT ptOrigen = {0, 0};
    // El fondo del juego se pinta primero
    g_pFondoJuego->Dibujar(hDC, ptOrigen);

    // Ahora dibuja los sprites desde el vector
    // que pertenece al NucleoMotor
    g_pJuego->DibujarSprites(hDC);

    TCHAR szTexto[90];
    wsprintf(szTexto, "Aviones: %d - Abatidos %d - Bombas: %d - Interceptadas: %d - Misiles: %d , Fallados = %d",
        g_iAtaque, g_iAvionesAbatidos, g_iBombasExplotadas, g_iBombasInterceptadas, g_iMisil, g_iMisilesFallados);
    TextOut(hDC, 0, 0, szTexto, strlen(szTexto));

}
void FJ_CicloJuego()
{
    if (!g_bFinJuego)
    {
        // Se acaba el juego si...
        // 1. se acaban los aviones y sus bombas
        // 2. se acaban los misiles
        // 3. se acaban por destruccin de la batera antiarea
        if ((g_iQShots == g_iBombasExplotadas + g_iBombasInterceptadas) ||
            (g_iQShots <= g_iAvionesAbatidos + g_iBombasInterceptadas + g_iMisilesFallados) ||
            (g_bCanonDestruido))
        {
            TCHAR szTexto[100];
            wsprintf(szTexto, "Fin del juego! Su rcord es %d aviones abatidos y %d intercepciones de bombas,  %d misiles errados. (F3= Nuevo juego)",
                g_iAvionesAbatidos, g_iBombasInterceptadas, g_iMisilesFallados);
            MessageBox(g_pJuego->ObtenerVentana(), szTexto, TEXT("Blitzkrieg"), MB_OK);
            g_bFinJuego = true;
            // Pausar la msica de fondo
            g_pJuego->MIDI(PAUSARMIDI);
            return;
        }
        // Cada 25 ciclos parte un avin
        // Se asignan velocidades y alturas de modo aleatorio
        int iY = rand() % (g_pJuego->ObtenerAltura()/3);
        int iVeloAvion = rand() % 20 + 5;
        int iVeloBomba = rand() % 10 + 5;
        // Se lanzan los bombarderos, de a uno y cada x ciclos
        if ((g_iContBucle % 25 == 0) && (g_iAtaque < g_iQShots))
        {
            g_iAtaque++;
            int i = g_iAtaque - 1;
            if (i % 2 == 0)
            {
                // aviones pares salen desde la izquierda
                g_pcsAvion[i]->AsignarPosicion(0,iY);
                g_pcsAvion[i]->AsignarVelocidad(iVeloAvion,0);
                g_pcsAvion[i]->AsignarVisibilidad(true);

                g_pcsBomba[i]->AsignarVelocidad(iVeloBomba,iVeloBomba + 7);
                g_pcsBomba[i]->AsignarPosicion(g_pcsAvion[i]->ObtenerAncho(),
                        iY + g_pcsAvion[i]->ObtenerAltura());
                g_pcsBomba[i]->AsignarVisibilidad(true);
            }
            else
            {
                // Aviones impares salen desde la derecha
                g_pcsAvion[i]->AsignarPosicion(g_pJuego->ObtenerAncho()
                        - g_pcsAvion[i]->ObtenerAncho(), iY);
                g_pcsAvion[i]->AsignarVelocidad(-iVeloAvion,0);
                g_pcsAvion[i]->AsignarVisibilidad(true);

                g_pcsBomba[i]->AsignarVelocidad(-iVeloBomba,iVeloBomba + 6);
                g_pcsBomba[i]->AsignarPosicion(g_pJuego->ObtenerAncho()
                        - g_pcsAvion[i]->ObtenerAncho(),
                        iY + g_pcsAvion[i]->ObtenerAltura());
                g_pcsBomba[i]->AsignarVisibilidad(true);
            }
        }
        // Actualiza las posiciones de los sprites
        g_pJuego->ActualizarSprites();
        ++g_iContBucle;

        // Pintar en el contexto de dispositivo
        // auxiliar para eliminar
        // la sensacin de parpadeo
        FJ_PintarJuego(g_hBuferAuxDC);

        // Pintura real de la pantalla en una nica operacin
        HWND hVentana = g_pJuego->ObtenerVentana();
        HDC hDC = GetDC(hVentana);

        // se utilizan coordenadas 0, 0
        // porque se realiza copia completa
        // de un rea a otra
        BitBlt(hDC,
            0, 0, g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura(),
            g_hBuferAuxDC, 0, 0,
            SRCCOPY);

        ReleaseDC(hVentana, hDC);

        // Se depuran los sprites marcados para eliminar
        g_pJuego->DepurarSprites();
    }
}
void FJ_LButtonDown(LPARAM lParam)
{
   // Botn izquierdo reinicia el juego
   if (g_bFinJuego)
     FJ_NuevoJuego();
}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{
}
void FJ_CheckTeclado()
{
    if (GetAsyncKeyState(VK_F3) < 0)
        FJ_NuevoJuego();
}
void FJ_TeclaCaracter(WPARAM wParam)
{
    // salen a distintas direcciones
    // esto se resuelve con diferentes velocidades
    // sobre el eje x y el eje y
    if (g_iMisil == g_iQShots)
        return;

    // Conversin de la tecla a nmero
    int iTecla = int(wParam) - 48;

    // Se usa una funcin auxiliar comn para teclado y joystick
    Misil(iTecla);
}
void Misil(int iDisparo)
{
    int i;
    if (iDisparo > 0 && iDisparo < 8)
    {
        g_iMisil++;
        i = g_iMisil - 1;
        g_pcsMisil[i]->AsignarVisibilidad(true);
        PlaySound((LPCSTR) IDW_DISPARO, g_pJuego->ObtenerInstancia(),
                            SND_ASYNC | SND_RESOURCE);
    }

    switch (iDisparo)
    {
        case 1:
            g_pcsMisil[i]->AsignarVelocidad(-11,-3);
            break;
        case 2:
            g_pcsMisil[i]->AsignarVelocidad(-8, -8);
            break;
        case 3:
            g_pcsMisil[i]->AsignarVelocidad(-6,-10);
            break;
        case 4:
            g_pcsMisil[i]->AsignarVelocidad(0, -12);
            break;
        case 5:
            g_pcsMisil[i]->AsignarVelocidad(6,-10);
            break;
        case 6:
            g_pcsMisil[i]->AsignarVelocidad(8,-8);
            break;
        case 7:
            g_pcsMisil[i]->AsignarVelocidad(11, -3);
        break;
    }
}
void FJ_CheckJoystick(WORD wJoyEstado)
{
    // El joystick permite una definicin de 7 direcciones de
    // lanzamiento de misiles
    // Botn 3: Termina el juego y reinicia otro
    if (wJoyEstado & JBOT3)
    {
        FJ_NuevoJuego();
        return;
    }
    if (g_iMisil == g_iQShots)
        return;


    // Los botones IZQ, DER y ARRIBA
    // del joystick sirven para
    // elegir la direccin del misil
    if (wJoyEstado & JIZQ)
        g_iDireccionMisil--;
    if (wJoyEstado & JDER)
        g_iDireccionMisil++;
    // 4 es el misil vertical
    if (wJoyEstado & JARRIBA)
        g_iDireccionMisil = 4;

    // El rango de direcciones es de 1 a 7
    // 1, 2 y 3 son direcciones hacia la izquierda
    // 4 es un misil vertical
    // 5, 6, y 7 son direcciones hacia la derecha
    g_iDireccionMisil = max(g_iDireccionMisil,1);

    g_iDireccionMisil = min(g_iDireccionMisil,7);

    // El botn 1 dispara el misil
    if (wJoyEstado & JBOT1)
        Misil(g_iDireccionMisil);
}

APC_ACCION FJ_NotificarColision(TC_COLISION tcColision, cSprite* pSprite, cSprite* pSpriteImpactado)
{
  // Si el objeto impactado es el caracol
  // se pierde una vida y se recomienza
  // el juego hasta llegar
  // a la cantidad de vidas

     switch (tcColision)
     {
        case TC_SPRITE:
            if (pSprite->ObtenerDensidad() == 0 || pSpriteImpactado->ObtenerDensidad() == 0)
                return APC_NOACCION;

            if (pSprite->ObtenerID() == MISIL || pSpriteImpactado->ObtenerID() == MISIL)
            {
                // si se impacta un avin se sumariza
                if (pSprite->ObtenerID() == AVION || pSpriteImpactado->ObtenerID() == AVION)
                {
                    g_iAvionesAbatidos++;
                    PlaySound((LPCSTR) IDW_MISIL, g_pJuego->ObtenerInstancia(),
                        SND_ASYNC | SND_RESOURCE);
                       // si slo se tiene 1 misil se pone
                       // la msica de suspenso
                    if (g_iAtaque == g_iQShots - 1)
                        g_pJuego->MIDI(PLAYMIDI,TEXT("unavida.mid"));
                    return APC_DESTRUIR2;
                }
                if (pSprite->ObtenerID() == BOMBA || pSpriteImpactado->ObtenerID() == BOMBA)
                {
                    g_iBombasInterceptadas++;
                    return APC_DESTRUIR2;
                }
            }
            else
            {
                if (pSpriteImpactado->ObtenerID() == CANON)
                {
                    // Pone la imagen de las llamas
                    pSpriteImpactado->CambiarImagen();
                    // a partir de hora ya ningn objeto
                    // podr impactar con los restos del can
                    pSpriteImpactado->AsignarDensidad(0);
                    PlaySound((LPCSTR) IDW_KO, g_pJuego->ObtenerInstancia(),
                            SND_ASYNC | SND_RESOURCE);
                    // Can destrudo
                    g_bCanonDestruido = true;
                }
            }
            break;
        case TC_LIMITES:
            if (pSprite->ObtenerID() == BOMBA)
            {
                PlaySound((LPCSTR) IDW_BOMBA, g_pJuego->ObtenerInstancia(),
                    SND_ASYNC | SND_RESOURCE);
                g_iBombasExplotadas++;
                pSprite->AsignarDensidad(0);
                pSprite->CambiarImagen();
                return APC_NOACCION;
            }
            if (pSprite->ObtenerID() == MISIL)
            {
                g_iMisilesFallados++;
                pSprite->AsignarVisibilidad(false);
                return APC_DESTRUIR;
            }
            break;
        // otras opciones
        // reservamos para uso futuro
    }
    return APC_NOACCION;
}


void FJ_NuevoJuego()
{
  // Funcin de limpieza de las variables
  // para reiniciar un nuevo
  g_pJuego->LimpiarVector();    // Se limpian los sprites del vector
  g_iAtaque = 0;                // Aviones lanzados
  g_iMisil = 0;                 // Misiles lanzados
  g_iBombasExplotadas = 0;      // Bombas explotadas
  g_iBombasInterceptadas = 0;   // Bombas interceptadas
  g_iMisilesFallados = 0;       // Misiles fallados
  g_iAvionesAbatidos = 0;       // Aviones abatidos
  // El misil 4 es el vertical
  g_iDireccionMisil = 4;        // Misil seleccionado

  g_bFinJuego = false;          // Indicador de fin de juego
  g_bCanonDestruido = false;    // Indicador de can destruido

  // Se define un rectngulo para el lmite
  // del movimiento de los aviones: media pantalla (superior)
  RECT rcAreaAvion = {0, 0,
        g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura()/2};
  // el rea de movimiento de los misiles es toda
  // la pantalla
  RECT rcAreaJuego = {0, 0,
        g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura()};
  // el rea de movimiento de las bombas
  // la asignaremos de modo individual
  RECT rcAreaBomba = {0, 0, 0, 0};

  // Definimos un hot spot menor que el
  // rectgulo del mapa de bits del avin
  // el mapa de bits es de 124 x 32
  // por lo tanto, el rea sensible
  // es bastante menor 80 x 25
  RECT rcHotSpot = {20, 5, 100, 30};


  // Se aaden los aviones y sus bombas
  // se definen sin visibilidad para ir
  // liberndolos de a poco
  for (int i = 0; i < g_iQShots; i++)
  {
    // Los aviones pares salen desde la izquierda
    // los impares salen desde la derecha
    int iOrdenZ = i % 2;
    // El mismo indicador del ordenZ nos sirve para
    // definir si se muestra el avin 0 o 1
    g_pcsAvion[i] = new cSprite(g_pAvion[iOrdenZ],
                    rcAreaAvion, AFL_DESAPARECER);

    // el orden Z es importante para definir
    // si pasa por adelante o por atrs de
    // las nubes: puede ser 1 o 2
    g_pcsAvion[i]->AsignarOrdenZ(iOrdenZ+1);
    g_pcsAvion[i]->AsignarHotSpot(rcHotSpot);

    // los aviones tienen identificadores 100
    g_pcsAvion[i]->AsignarID(AVION);
    // Los aviones nacen no visibles
    g_pcsAvion[i]->AsignarVisibilidad(false);
    // Se asigna una imagen para utilizarla cuando
    // se produzca una colisin con un misil
    g_pcsAvion[i]->AsignarcBmpImpacto(g_pImpactoMisil);
    g_pJuego->AgregarSprite(g_pcsAvion[i]);

    // Este detalle es interesante:
    // la bomba explota a diferentes alturas
    // para dar la impresin que caen en
    // distintas zonas de la ciudad
    int iAltura = g_pJuego->ObtenerAltura() - rand()
                        % g_pJuego->ObtenerAltura() / 2;
    SetRect(&rcAreaBomba, 0, 0, g_pJuego->ObtenerAncho(), iAltura);

    g_pcsBomba[i] = new cSprite(g_pBomba, rcAreaBomba, AFL_DETENER);
    // No se define un hot spot dado que
    // el bitmap es muy ajustado y el tamao
    // del bitmap coincide con el hot spot

    // El orden Z es el mismo que el del avin
    g_pcsBomba[i]->AsignarOrdenZ(iOrdenZ+1);

    // las bombas tienen identificadores 200
    g_pcsBomba[i]->AsignarID(BOMBA);
    g_pcsBomba[i]->AsignarVisibilidad(false);

    // Se asigna un mapa de bits que se muestra
    // al impactar
    g_pcsBomba[i]->AsignarcBmpAlternativo(g_pImpactoBomba);
    g_pJuego->AgregarSprite(g_pcsBomba[i]);
  }

  // Objeto Nube
  // Densidad = 0 (no es colisionable)
  // por defecto se definen con densidad 5
  cSprite* cSTemp;
  cSTemp = new cSprite(g_pNube, rcAreaAvion, AFL_REAPARECER);
  cSTemp->AsignarOrdenZ(1);
  cSTemp->AsignarID(PAISAJE);
  cSTemp->AsignarDensidad(0);
  // La nube se mueve lentamente
  cSTemp->AsignarVelocidad(1,0);
  g_pJuego->AgregarSprite(cSTemp);

  // Creamos el sprite del lanza misiles (can)
  cSTemp = new cSprite(g_pCanon, rcAreaJuego, AFL_DETENER);
  cSTemp->AsignarOrdenZ(0);
  cSTemp->AsignarID(CANON);
  cSTemp->AsignarPosicion((g_pJuego->ObtenerAncho()-
                        g_pCanon->ObtenerAncho())/2,
                        g_pJuego->ObtenerAltura()-
                        g_pCanon->ObtenerAltura() /2);

  // El can tiene un punto sensible muy pequeo
  // si recibe un impacto se termina el juego
  SetRect(&rcHotSpot, 72,35,77,40);
  cSTemp->AsignarHotSpot(rcHotSpot);
  cSTemp->AsignarcBmpImpacto(g_pImpactoBomba);
  cSTemp->AsignarcBmpAlternativo(g_pCanonEnLlamas);

  // El can es esttico
  cSTemp->AsignarVelocidad(10,0);
  g_pJuego->AgregarSprite(cSTemp);


  for (int i = 0; i < g_iQShots; i++)
  {
    g_pcsMisil[i] = new cSprite(g_pMisil,
                            rcAreaJuego,
                            AFL_DESAPARECER);
    // No se define un hot spot dado que
    // el bitmap es muy ajustado y el tamao
    // del bitmap coincide con el hot spot
    g_pcsMisil[i]->AsignarOrdenZ(2);
    g_pcsMisil[i]->AsignarPosicion(g_pJuego->ObtenerAncho()/2,
            g_pJuego->ObtenerAltura()-50);

    g_pcsMisil[i]->AsignarVisibilidad(false);
    g_pcsMisil[i]->AsignarcBmpImpacto(g_pImpactoMisil);
    // los proyectiles tienen identificadores MISIL = 300
    g_pcsMisil[i]->AsignarID(MISIL);
    g_pJuego->AgregarSprite(g_pcsMisil[i]);
  }

  // Contamos la cantidad de ciclos
  g_iContBucle = 0;
  // Reinicia la reproduccin de la msica de fondo
  g_pJuego->MIDI(PLAYMIDI, TEXT("fondo.mid"));
}
