//------------------------------------
// Archivo de encabezamiento Blitzkrieg.h
//-------------------------------------
#pragma once

//-------------------------
// Archivos de inclusin
//-------------------------
#include <windows.h>
#include "Recursos.h"
#include "NucleoMotor.h"
#include "cBMP.h"
#include "cSprite.h"

//------------------------
// Variable globales
//------------------------
// objeto juego
NucleoMotor*    g_pJuego;

// Cantidad de aviones y misiles
const int       g_iQShots = 40;

// Bitmaps del juego
cBMP *          g_pAvion[2];
cBMP *          g_pBomba;
cBMP *          g_pMisil;
cBMP *          g_pNube;
cBMP *          g_pCanon;
cBMP *          g_pFondoJuego;

// Bitmaps de impactos
cBMP *          g_pImpactoBomba;
cBMP *          g_pImpactoMisil;
cBMP *          g_pCanonEnLlamas;

// Sprites (mapas de bits con animacin)
cSprite *       g_pcsAvion[g_iQShots];
cSprite *       g_pcsMisil[g_iQShots];
cSprite *       g_pcsBomba[g_iQShots];

// ndices para las matrices de sprites
int             g_iAtaque;
int             g_iMisil;

// Contadores del juego
int             g_iBombasInterceptadas;
int             g_iBombasExplotadas;
int             g_iMisilesFallados;
int             g_iAvionesAbatidos;
int             g_iDireccionMisil;
// Variable auxiliar para contar bucles
// til para la depuracin y para
// ciertas lgicas de animacin
int             g_iContBucle;

// Indicador de fin de juego
BOOL            g_bFinJuego;
BOOL            g_bCanonDestruido;

// Demora para el teclado
int             g_iRetenerInput = 0;

// Para bfer auxiliar para
// eliminar el parpadeo
HDC             g_hBuferAuxDC;
HBITMAP         g_hBuferAuxBitmap;

// Constantes para identificar los objetos
typedef         INT         TIPO_OBJ;
const           TIPO_OBJ    AVION = 100,
                            BOMBA = 200,
                            MISIL = 300,
                            CANON = 400,
                            PAISAJE = 500;

// Funcin auxiliar de Blitzkrieg.cpp
void Misil(int iDisparo);

