//-----------------------------------------------------------------
// Archivo de cdigo C++ - CruzRaya.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "CruzRaya.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("CruzRaya"), TEXT("CruzRaya"),
    IDI_CRUZRAYA, IDI_CRUZRAYA_SM,
    300, 300, 10);

  if (g_pJuego == NULL)
    return FALSE;

  return TRUE;
}

void FJ_ComenzarJuego(HWND hWindow)
{
  // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);

  // Crea los objetos cBMP a partir de archivos bmp
  // Los mapas de bits son de profundidad 24 bits

  // de modo directo desde archivos bmp
  g_pMarcas[0] = new cBMP(hDC, TEXT("Recursos//equis.bmp"));
  g_pMarcas[1]= new cBMP(hDC, TEXT("Recursos//circulo.bmp"));
  g_pFinJuego= new cBMP(hDC, TEXT("Recursos//finjuego.bmp"));

  // como recurso de la aplicacin
  g_pFondoJuego = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());

  // Limpieza de la matriz de 3 x 3
  // Cuando tiene el valor 2 significa vaco
  // 0 significa una equis
  // 1 significa un crculo
  for (int iFila = 0; iFila < 3; iFila++)
      for(int iCol = 0; iCol < 3; iCol++)
        g_iCuadros[iFila][iCol] = 2;

   g_bFinJuego = false;

   // siempre se empieza con la X
   g_bTurnoEquis = true;

   // Para indicar que se deb mostrar la pantalla
   g_bMostrar = true;

   // Contamos la cantidad de ciclos
   // En este proyecto no tiene utilidad, salvo que queramos
   // realizar alguna depuracin del cdigo
   g_iContBucle = 0;

}

void FJ_FinalizarJuego()
{

  // Elimina objetos de mapas de bits
  for (int i = 0; i < 2; i++)
    delete g_pMarcas[i];

  delete g_pFinJuego;
  delete g_pFondoJuego;

  // Elimina el objeto
  delete g_pJuego;
}

void FJ_ReactivarJuego(HWND hWindow)
{
}

void FJ_DetenerJuego(HWND hWindow)
{
}

void FJ_PintarJuego(HDC hDC)
{


    POINT ptDibujo = {0, 0};
    // Dibuja el fondo
    g_pFondoJuego->Dibujar(hDC, ptDibujo);

    // Se pone en tru el final del juego
    g_bFinJuego = true;

    // Se analiza cada uno de los elementos
    // de la matriz para determinar qu se
    // dibujar encada cuadro del juego
    for (int iCol = 0; iCol < 3; iCol++)
      for(int iFila = 0; iFila < 3; iFila++)
      {
        // si es 2, no debe dibujar nada
        if (g_iCuadros[iFila][iCol] != 2)
        {
            // calcula las coordenadas del dibujo
            ptDibujo.x = iCol * 100;
            ptDibujo.y = iFila * 100;
            // Segn el valor dibuja una equis o un crculo
            g_pMarcas[g_iCuadros[iFila][iCol]]->Dibujar(hDC, ptDibujo,
                    TRUE, RGB(255, 0, 255));
        }
        else
            // Mientras haya un cuadro sin asignar, se puede
            // seguir jugando (salvo que
            // despus se detecten tres en raya
            g_bFinJuego = false;
      }
    // Controla si alguno alguno de los jugadores ha ganado
    if (ControlarFinJuego(0) || ControlarFinJuego(1))
    {
       // Coloca el mapa de bits de fin de juego
       ptDibujo.x = g_pJuego->ObtenerAncho() / 3;
       ptDibujo.y = g_pJuego->ObtenerAltura() / 3;
       g_pFinJuego->Dibujar(hDC, ptDibujo, TRUE, RGB(255, 0, 255));
       g_bFinJuego = true;
    }
    // No debe volver a dibujar hasta el siguiente cambio
    g_bMostrar = false;


}

void FJ_CicloJuego()
{

    // Contador de bucles
    // No tiene una funcionalidad asignada
    ++g_iContBucle;

    // para evitar el parpadeo cuando no hay nada nuevo
    // no hace falta redibujar la pantalla
    if (g_bMostrar)
    // Invalida la ventana para forzar el repintado
      InvalidateRect(g_pJuego->ObtenerVentana(), NULL, FALSE);

}
void FJ_LButtonDown(LPARAM lParam)
{
    // Se puls el botn izquierdo del ratn
    POINT ptCoord = {LOWORD(lParam), HIWORD(lParam)};

    // si no termin el juego
    // se analiza el clic
    if (!g_bFinJuego)
    {
        // Determina qu panel recibi el clic
        int iCol = ptCoord.x / 100;
        int iFila = ptCoord.y / 100;

        // Los cuadros con equis o crculo no
        // nos interesan (slo los cuadros no marcados)
        if (g_iCuadros[iFila][iCol] == 2)
        {
            // Verifica quin ha jugado
            if (g_bTurnoEquis)
            {
               g_iCuadros[iFila][iCol] = 0;
               g_bTurnoEquis = false;
            }
            else
            {
               g_iCuadros[iFila][iCol] = 1;
               g_bTurnoEquis = true;
            }
            g_bMostrar = true;
        }
    }
    else
    {
        // Cuando el juego ha finalizado
        // el clic indica el comienzo de un nuevo juego
        g_bFinJuego = false;
        // Limpia la matriz
        for (int iCol = 0; iCol < 3; iCol++)
            for(int iFila = 0; iFila < 3; iFila++)
            g_iCuadros[iFila][iCol] = 2;
             // siempre se empieza con la X
        g_bTurnoEquis = true;
        g_bMostrar = true;
    }


}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{

}
bool ControlarFinJuego(int iPlayer)
{
    // Control soluciones horizontales
    for (int iFila = 0; iFila < 2; iFila++)
        if (g_iCuadros[iFila][0] == g_iCuadros[iFila][1] &&
            g_iCuadros[iFila][0] == g_iCuadros[iFila][2] &&
            g_iCuadros[iFila][0] == iPlayer)
               return true;
    // Control de soluciones verticales
    for (int iCol = 0; iCol < 2; iCol++)
        if (g_iCuadros[0][iCol] == g_iCuadros[1][iCol] &&
            g_iCuadros[0][iCol] == g_iCuadros[2][iCol] &&
            g_iCuadros[0][iCol] == iPlayer )
               return true;

    // Control de soluciones diagonales
    if (g_iCuadros[0][0] == g_iCuadros[1][1] &&
        g_iCuadros[0][0] == g_iCuadros[2][2] &&
        g_iCuadros[0][0] == iPlayer )
               return true;
    if (g_iCuadros[0][2] == g_iCuadros[1][1] &&
        g_iCuadros[0][2] == g_iCuadros[2][0] &&
        g_iCuadros[0][2] == iPlayer )
               return true;

    return false;
}

