//-----------------------------------------------------------------
// Archivo de cdigo C++ - Detonacion.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "Detonacion.h"

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("Detonacion"), TEXT("Detonacion"),
    IDI_DETONACION, IDI_DETONACION_SM,
    500, 500, 1); // frecuencia 1 fps

  if (g_pJuego == NULL)
    return false;

  return true;
}

void FJ_ComenzarJuego(HWND hWindow)
{
  // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);


  // Crea los mapas de bits a partir de los recursos
  // Los mapas de bits son de profundidad 24 bits
  g_pFondoJuego = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());
  g_pDinamita1 = new cBMP(hDC, IDB_BMP2, g_pJuego->ObtenerInstancia());
  g_pDinamita2 = new cBMP(hDC, IDB_BMP3, g_pJuego->ObtenerInstancia());
  g_pExplosion = new cBMP(hDC, IDB_BMP4, g_pJuego->ObtenerInstancia());
  g_pFinDelJuego = new cBMP(hDC, IDB_BMP5, g_pJuego->ObtenerInstancia());

  srand(GetTickCount());

  // Llama a una funcin para
  // inicar los contadores
  FJ_NuevoJuego();

  // Bfer auxiliar de repintado
  // Crea un contexto de dispositivo y un
  // mapa de bits adicional
  g_hBuferAuxDC = CreateCompatibleDC(hDC);
  g_hBuferAuxBitmap = CreateCompatibleBitmap(hDC,
      g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura());
  SelectObject(g_hBuferAuxDC , g_hBuferAuxBitmap);

}
void FJ_NuevoJuego()
{
  for (int i = 0; i < 5 ; i++)
  {
    // las dinamitas cargadas estn
    // pintadas de rojo
    g_bCargaActivada[i] = true;
    // Estos son los nmeros que habr
    // que averiguar
    // se asignan valores aleatorios
    // entre 0 y 9
    g_iNumeros[i]= rand() % 10;
  }

  // Este valor es mayor a los valores que
  // se pueden introducir
  g_iValorEntrado = 10;

  // Contamos la cantidad de ciclos
  g_iContBucle = 0;
  // Tiempo disponible para desactivas
  // las dinamitas
  g_iSegundos = 65;
  // Adivinados
  g_iAdivinar = 0;
  // Intentos disponibles
  g_iIntentos = 20;
  // Indicador del fin del juego
  g_bFinJuego = false;
}

void FJ_FinalizarJuego()
{
  // Elimina los elementos del bfer auxiliar
  DeleteObject(g_hBuferAuxBitmap);
  DeleteObject(g_hBuferAuxDC);

 // Elimina objetos
  delete g_pDinamita1;
  delete g_pDinamita2;
  delete g_pFinDelJuego;
  delete g_pExplosion;
  delete g_pFondoJuego;

  // Elimina el objeto juego
  delete g_pJuego;
}

void FJ_ReactivarJuego(HWND hWindow)
{
}

void FJ_DetenerJuego(HWND hWindow)
{
}

void FJ_PintarJuego(HDC hDC)
{
    // Mientras el juego est en estado
    // finalizado el juego no se
    // actualiza la interfaz
    if (g_bFinJuego)
        return;

    // Fondo del juego
    POINT ptOrigen = {0, 0};
    g_pFondoJuego->Dibujar(hDC, ptOrigen);

    // Compara dato entrado con el valor que debe
    // adivinar (siempre en orden ascendente, no se
    // puede desactivar una dinamita si no se
    // desactiva la anterior)
    TCHAR szTextoGuia[40];
    if (g_iValorEntrado == 10)
        wsprintf(szTextoGuia, "Introducir un nmero entre 0 y 9...");
    else
    {
        if (g_iNumeros[g_iAdivinar] < g_iValorEntrado)
            wsprintf(szTextoGuia, "%d es muy grande", g_iValorEntrado);
        if (g_iNumeros[g_iAdivinar] > g_iValorEntrado)
            wsprintf(szTextoGuia, "%d es muy pequeo", g_iValorEntrado);
        if (g_iNumeros[g_iAdivinar] == g_iValorEntrado)
        {
            wsprintf(szTextoGuia, "% es correcto", g_iValorEntrado);
            g_bCargaActivada[g_iAdivinar] = false;
            g_iAdivinar++;
            g_iValorEntrado = 10;
        }
    }
    // Fuente para el texto de la cantidad de intentos
    // y la ayuda que se muestra para orientar al
    // jugador
    HFONT hFuente = CreateFont(15, 0, 0, 0, 700, FALSE, FALSE, FALSE,
          DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
          PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Arial");

    SelectObject(hDC, hFuente);
    TextOut(hDC, 230, 430, szTextoGuia, strlen(szTextoGuia));
    wsprintf(szTextoGuia, "Quedan %d intentos", g_iIntentos);
    TextOut(hDC, 230, 370, szTextoGuia, strlen(szTextoGuia));
    DeleteObject(hFuente);

    // Dibuja las dinamitas del color que
    // corresponda: rojo activada y
    // verde desactivada
    for (int i = 0; i <5 ; i++)
    {
        POINT ptDinam;
        ptDinam.x = 120;
        ptDinam.y = 216 - i * 50;
        if (g_bCargaActivada[i])
          g_pDinamita1->Dibujar(hDC, ptDinam, true, RGB(255, 0, 255));
        else
          g_pDinamita2->Dibujar(hDC, ptDinam, true, RGB(255, 0, 255));
    }
    // Reloj que muestra el tiempo transcurrido
    hFuente = CreateFont(-80, 0, 0, 0, 700, FALSE, FALSE, FALSE,
            DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
            PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Times New Roman");

    SelectObject(hDC, hFuente);
    TCHAR szTexto[90];
    wsprintf(szTexto, "%d", g_iSegundos--);

    TextOut(hDC, 60, 370, szTexto, strlen(szTexto));
    DeleteObject(hFuente);

    // Controlar si se termina el juego
    if (g_iAdivinar < 5)
    {
        if (g_iSegundos == 0 || g_iIntentos == 0)
        {
            // El juego termina al pasar el tiempo en segundos
            // o la cantidad de intentos disponibles
            // El jugador perdi!
            POINT ptFin;
            ptFin.x = (g_pJuego->ObtenerAncho() - g_pExplosion->ObtenerAncho())/2;
            ptFin.y = (g_pJuego->ObtenerAltura() - g_pExplosion->ObtenerAltura())/2;
            g_pExplosion->Dibujar(hDC, ptFin, true, RGB(255, 0, 255));
            g_bFinJuego = true;
        }
    }
    else
    {
        // El jugador gan!!
        POINT ptFin;
        ptFin.x = (g_pJuego->ObtenerAncho() - g_pFinDelJuego->ObtenerAncho())/2;
        ptFin.y = (g_pJuego->ObtenerAltura()  - g_pFinDelJuego->ObtenerAltura())/2;
        g_pFinDelJuego->Dibujar(hDC, ptFin, true, RGB(255, 0, 255));
        g_bFinJuego = true;
    }
}

void FJ_CicloJuego()
{
    // Se controlan los bucles del juego
    // a veces es til para la depuracin
    // del programa o para alguna funcin
    // del juego
    ++g_iContBucle;

    // Se dibuja en el bfer auxiliar
    FJ_PintarJuego(g_hBuferAuxDC);

    HWND hVentana = g_pJuego->ObtenerVentana();
    HDC hDC = GetDC(hVentana);

    // se utilizan coordenadas 0, 0
    // porque se realiza copia completa
    // de un rea a otra
    BitBlt(hDC,
        0, 0, g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura(),
        g_hBuferAuxDC, 0, 0,
        SRCCOPY);

    ReleaseDC(hVentana, hDC);


}
void FJ_LButtonDown(LPARAM lParam)
{
    // Renicia el juego
    FJ_NuevoJuego();
}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{
}

void FJ_CheckTeclado()
{
    // Tecla F3-> reinicia el juego
    if (GetAsyncKeyState(VK_F3) < 0)
        FJ_NuevoJuego();
}
void FJ_TeclaCaracter(WPARAM wParam)
{
    // Conversin de la tecla a nmero
    g_iValorEntrado = int(wParam) - 48;
    // Cada entrada de datos resta en 1 las
    // posibilidades disponibles
    g_iIntentos--;
}
void FJ_CheckJoystick(WORD wJoyEstado)
{
}

