//-----------------------------------------------------------------
// Aplicacin DibujosGDI
// Cdigo fuente C++  - DibujosGDI.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "DibujosGDI.h"

//-----------------------------------------------------------------
// Funciones del juego
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo motor del juego
  // Se define un rea de juego de 400 x 200
  // y una frecuencia de 20 ciclos por segundos
  // (1 ciclo cada 50 ms)
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("DibujosGDI"),
    TEXT("DibujosGDI"),
    IDI_DIBUJOSGDI,
    IDI_DIBUJOSGDI_SM,
    600, 500, 20);

  // Si no pudo crear el objeto devuelve False
  if (g_pJuego == NULL)
    return FALSE;

  srand(GetTickCount());

  return TRUE;
}

void FJ_ComenzarJuego(HWND hVentana)
{

   // Se cuentan los ciclos
   g_iCiclos = 0;

   // se calcula la cantidad de filas y columnas
   // para dibujar un tablero con cuadros de 100 x 100
   g_iCols = g_pJuego->ObtenerAncho()/100;
   g_iRows = g_pJuego->ObtenerAltura()/100;

}

void FJ_FinalizarJuego()
{
  // destruye el objeto ncleo motor
  delete g_pJuego;
}
void FJ_ReactivarJuego(HWND hVentana)
{
}

void FJ_DetenerJuego(HWND hVentana)
{
}

void FJ_PintarJuego(HDC hDC)
{
    // Pinta un fondo de color verde
    RECT miRect;
    // handle de la ventana
    HWND hVentana = g_pJuego->ObtenerVentana();

    // obtiene el rectngulo de la ventana cliente
    GetClientRect(hVentana, &miRect);

    // Crea una brocha uniforme (slida) de color verde
    HBRUSH hBrocha= CreateSolidBrush(RGB(0,255,0));

    // Pinta el fondo del juego
    FillRect(hDC, &miRect, hBrocha);
    DeleteObject(hBrocha);
}

void FJ_CicloJuego()
{
  HDC   hDC;
  HWND  hVentana;

    // handle de la ventana
    hVentana = g_pJuego->ObtenerVentana();

    // Caen los meteoritos en sitios ordenados de la pantalla
    // Obtiene un contexto de dispositivo
    hDC = GetDC(hVentana);

    // Creamos una pluma roja y uniforme
    HPEN hPen = CreatePen(PS_SOLID, 5, RGB(255, 0, 0));
    SelectObject(hDC, hPen);

    // Elige al azar un punto de inicio
    // el vrtice de alguno de los
    // cuadros del tablero
    int x = rand() % g_iCols * 100;
    int y = rand() % g_iRows * 100;

    // limpia el rectngulo
    // por si tiene informacin

     // Repinta un fondo de color verde
     // el el cuadro en el que tiene que
     // dibujar algo
    RECT miRect;
    SetRect(&miRect, x, y,
            x + 100, y +100);
    // Crea una brocha uniforme (slida) de color gris
    // diferente al color de fondo inicial (verde)
    HBRUSH hBrocha= CreateSolidBrush(RGB(128,128,128));
    // Pinta el fondo del juego
    FillRect(hDC, &miRect, hBrocha);

    // en distintos ciclos va pintando
    // la interfaz
    int iCiclo = g_iCiclos % 8;
    switch(iCiclo)
    {
        case 1:
        // Pinta las lneas horizontales
            for (int i = 1; i < g_iRows; i++)
            {
                MoveToEx(hDC, 0, i *100, NULL);
                LineTo(hDC, g_pJuego->ObtenerAncho(), i* 100);
            }
            break;
        case 2:
        // Pinta las lneas verticales
           for (int i = 1; i < g_iCols; i++)
            {
                MoveToEx(hDC, i *100, 0, NULL);
                LineTo(hDC, i* 100, g_pJuego->ObtenerAltura());
            }
            break;
        case 3:
        // Dibuja texto en un cuadro
        // del tablero
            TextOut(hDC, x + 20, y + 20, TEXT("TEXTO"), 5);
            break;
        case 4:
        // Dibuja un rectngulo en
        // un cuadro del tablero
            Rectangle(hDC, x + 20, y + 20, x + 70, y + 70);
            break;
        case 5:
        // Dibuja un crculo en un
        // cuadro del tablero
            Ellipse(hDC, x + 10, y + 10, x + 70, y + 70);
            break;
        case 6:
        // Dibuja una elipse en un
        // cuadro del tablero
            Ellipse(hDC, x + 10, y + 10, x + 30, y + 70);
            break;
        case 7:
        // Dibuja un polgono en un
        // cuadro del tablero
        // array de estructura POINT
            POINT coord[5];
            coord[0].x = x + 10;
            coord[0].y = y + 40;
            coord[1].x = x + 5;
            coord[1].y = y + 90;
            coord[2].x = x + 80;
            coord[2].y = y + 80;
            coord[3].x = x + 10;
            coord[3].y = y + 15;
            coord[4].x = x + 90;
            coord[4].y = y + 50;
            // no hace falta cerrar el polgono
            // se cierra automticamente
            Polygon(hDC, coord, 5);
            break;
        default:
            break;
    }

    g_iCiclos++;
    // Elimina la pluma y la brocha
    DeleteObject(hPen);
    DeleteObject(hBrocha);
    // Libera el contexto de dispositivo
    ReleaseDC(hVentana, hDC);
}

