//-----------------------------------------------------------------
// Archivo de cdigo C++ - Memorex.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "MemorexSound.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("Memorex"), TEXT("Memorex"),
    IDI_MEMOREX, IDI_MEMOREX_SM,
    640, 480, 5); // frecuencia 50 fps

  if (g_pJuego == NULL)
    return FALSE;

  return true;
}
void FJ_ComenzarJuego(HWND hWindow)
{

     // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);

  // Los mapas de bits son de profundidad 24 bits
  // carta dada vuelta
  g_pCartas[0] = new cBMP(hDC, TEXT("Recursos//0.bmp"));
  // cartas con nmero
  g_pCartas[1] = new cBMP(hDC, TEXT("Recursos//1.bmp"));
  g_pCartas[2] = new cBMP(hDC, TEXT("Recursos//2.bmp"));
  g_pCartas[3] = new cBMP(hDC, TEXT("Recursos//3.bmp"));
  g_pCartas[4] = new cBMP(hDC, TEXT("Recursos//4.bmp"));
  g_pCartas[5] = new cBMP(hDC, TEXT("Recursos//5.bmp"));
  g_pCartas[6] = new cBMP(hDC, TEXT("Recursos//6.bmp"));
  g_pCartas[7] = new cBMP(hDC, TEXT("Recursos//7.bmp"));
  g_pCartas[8] = new cBMP(hDC, TEXT("Recursos//8.bmp"));
  g_pCartas[9] = new cBMP(hDC, TEXT("Recursos//9.bmp"));
  g_pCartas[10] = new cBMP(hDC, TEXT("Recursos//10.bmp"));
  g_pCartas[11] = new cBMP(hDC, TEXT("Recursos//j.bmp"));
  g_pCartas[12] = new cBMP(hDC, TEXT("Recursos//q.bmp"));
  g_pCartas[13] = new cBMP(hDC, TEXT("Recursos//k.bmp"));
  // Carta seleccionada
  g_pCartas[14] = new cBMP(hDC, TEXT("Recursos//0Select.bmp"));

  // Carga el mapa de bits del fin del juego
  g_pFinDelJuego = new cBMP(hDC, TEXT("Recursos//FinDelJuego.bmp"));

  // Fondo verde de la mesa del juego
  SIZE sizBmp = {g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura()};
  g_pFondoJuego = new cBMP(hDC, sizBmp, RGB(0, 255, 0));



}

void FJ_RecomenzarJuego(HWND hWindow)
{
  // Establece el estado de cada carta
  // false es oculta
  // true es adivinada
  for (int i = 0; i <14; i++)
    g_bCartaAdivinada[i] = false;

  // Panel de cartas:
  // el panel tiene 20 elementos para cubrir
  // toda la pantalla, pero las cartas se dispondrn
  // en las tres filas superiores
  for (int  i=0; i < 20; i++)
    g_iPanel[i] = 0;

  // Decide aleatoriamente qu carta va en cada sitio
  // las cartas son 13 (de 1 a K)
  srand(GetTickCount());
  for (int  i=1; i < 14; i++)
  {
      // cada nmero generado vendr de una secuencia diferente
      int j = rand() % 15;
      bool sin_asignar = true;
      while (sin_asignar)
      {
        if (g_iPanel[j] == 0)
        {
            sin_asignar = false;
            g_iPanel[j] = i;
        }
        else
        {
            j += 1;
            if (j > 14) j = 1;
        } // fin else
      } // fin while
  } // fin for


  // Indicadores del juego
  g_iIntentos = g_iFallos = 0;
  g_iCartaElegida = 0;
  g_iTeclaPulsada = 0;
  g_iElem = 999;
  g_bFinJuego = false;
  g_bMostrar = true;
  g_bMostrarAyuda = false;

  // Contamos la cantidad de ciclos
  g_iContBucle = 0;
}

void FJ_FinalizarJuego()
{
  // Elimina objetos mapas de bits
  for (int i = 0; i < 14; i++)
     delete g_pCartas[i];
  delete g_pFondoJuego;
  delete g_pFinDelJuego;

  // Elimina el objeto
  delete g_pJuego;
}

void FJ_ReactivarJuego(HWND hWindow)
{
}

void FJ_DetenerJuego(HWND hWindow)
{
}

void FJ_PintarJuego(HDC hDC)
{

    POINT ptOrigen = {0, 0};
    POINT ptInicio;
    // Mostrar ayuda:
    // ensea las cartas durante 1 ciclo
    if (g_bMostrarAyuda)
    {
        g_pFondoJuego->Dibujar(hDC, ptOrigen);;
        // Todos los paneles
        // Dibuja los 15 paneles
        for (int i = 0; i < 15; i++)
        {
        // Elige la posicin del mapa de bits
        ptInicio.x = (g_pCartas[0]->ObtenerAncho() * i) % g_pJuego->ObtenerAncho();
        ptInicio.y = (i / 5) *  g_pCartas[0]->ObtenerAltura();

        // carta con nmero
        g_pCartas[g_iPanel[i]]->Dibujar(hDC, ptInicio, TRUE, RGB(255, 0, 0));

        }
        g_bMostrarAyuda = false;
        // en el siguiente ciclo se
        // muestran las cartas tapadas
        // salvo las adivinadas
        g_bMostrar = true;
        return;
    }
    // Muestra el estado total del juego
    if (g_bMostrar)
    {
        g_pFondoJuego->Dibujar(hDC, ptOrigen);;
        // Todos los paneles
        // Dibuja los 15 paneles
        for (int i = 0; i < 15; i++)
        {
        // Elige la posicin del mapa de bits
        ptInicio.x = (g_pCartas[0]->ObtenerAncho() * i) % g_pJuego->ObtenerAncho();
        ptInicio.y = (i / 5) *  g_pCartas[0]->ObtenerAltura();

        if (g_iPanel[i] == 0)
          // carta nula era 0
          g_pCartas[0]->Dibujar(hDC, ptInicio, TRUE, RGB(255, 0, 0));
        else if(g_bCartaAdivinada[g_iPanel[i]] )
                // carta con nmero
                g_pCartas[g_iPanel[i]]->Dibujar(hDC, ptInicio);
             else if (i == g_iElem)
                    // carta seleccionada
                    g_pCartas[14]->Dibujar(hDC, ptInicio, TRUE, RGB(255, 0, 0));
                  else
                    // carta dada  vuelta
                    g_pCartas[0]->Dibujar(hDC, ptInicio, TRUE, RGB(255, 0, 0));
        }
        g_bMostrar = false;
    }


    // dibujo de la parte inferior
    // Dibuja el puntaje del jugador
    TCHAR szTexto[40];
    RECT rect={120, 400, 500, 450};
    wsprintf(szTexto, "F1 Ayuda : F3 Recomenzar : %d Fallos cometidos", g_iFallos);
    // OPAQUE borra con el color de fondo
    SetBkMode(hDC, OPAQUE);
    SetTextColor(hDC, RGB(255, 0, 0));
    DrawText(hDC, szTexto, -1, &rect, DT_SINGLELINE | DT_RIGHT | DT_VCENTER);

    // Comprobar si ha terminado
    int suma = 0;
    for (int i = 1; i < 14; i++)
        if (g_bCartaAdivinada[i])
          suma += 1;
    if (suma == 13)
    {
        POINT ptMedio;
        ptMedio.x = (g_pJuego->ObtenerAncho() - g_pFinDelJuego->ObtenerAncho())/2;
        ptMedio.y = (g_pJuego->ObtenerAltura() - g_pFinDelJuego->ObtenerAltura())/2;
        g_pFinDelJuego->Dibujar(hDC, ptMedio, TRUE, RGB(255, 0, 0));
        g_bFinJuego = true;
        PlaySound((LPCSTR)IDW_FIN, g_pJuego->ObtenerInstancia(), SND_ASYNC | SND_RESOURCE);
    }

}

void FJ_CicloJuego()
{

    ++g_iContBucle;
    // Invalida la ventana para forzar el repintado
    InvalidateRect(g_pJuego->ObtenerVentana(), NULL, FALSE);

}
void FJ_LButtonDown(LPARAM lParam)
{
    POINT ptCoord = {LOWORD(lParam), HIWORD(lParam)};
    g_ptClicked.x = ptCoord.x;
    g_ptClicked.y = ptCoord.y;

    // Determina qu panel recibi el clic
    int columna = ptCoord.x / g_pCartas[0]->ObtenerAncho();
    int fila = ptCoord.y / g_pCartas[0]->ObtenerAltura();

    // panel que recibe el clic
    g_iElem = columna + fila * 5;

    // Carta clicada
    g_iCartaElegida = g_iPanel[g_iElem];

    // Pero, si ya est dada vuelta
    if (g_bCartaAdivinada[g_iPanel[g_iElem]])
        // carta adivinada
        g_iCartaElegida = 0;
    else
        PlaySound((LPCSTR)IDW_SELECCIONADO, g_pJuego->ObtenerInstancia(), SND_ASYNC | SND_RESOURCE);
    g_bMostrar = true;


}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{
}
void FJ_TeclaCaracter(WPARAM wParam)
{
    if (g_iCartaElegida > 0)
    {
        switch (wParam)
        {
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
                g_iTeclaPulsada = int(wParam) - 48;
                break;
            case '0':
                g_iTeclaPulsada = 10;
                break;
            case 'J':
            case 'j':
                g_iTeclaPulsada = 11;
                break;
            case 'q':
            case 'Q':
                g_iTeclaPulsada = 12;
                break;
            case 'k':
            case 'K':
                g_iTeclaPulsada = 13;
                break;
            default:
                return;
           } // fin switch
        g_iIntentos += 1;
        if (g_iCartaElegida == g_iTeclaPulsada )
        {
            g_bCartaAdivinada[g_iCartaElegida] = true;
            g_bMostrar = true;
            PlaySound((LPCSTR)IDW_BIEN, g_pJuego->ObtenerInstancia(), SND_ASYNC | SND_RESOURCE);
        }
        else
        {
            g_iFallos += 1;
            PlaySound((LPCSTR)IDW_MAL, g_pJuego->ObtenerInstancia(), SND_ASYNC | SND_RESOURCE);
        } // fin if
    } // fin if

}

void FJ_CheckTeclado()
{
    if (GetAsyncKeyState(VK_F1) < 0)
    {
         // Muestra todas las cartas durante un ciclo
         // esto se penaliza con 5 intentos
         g_bMostrarAyuda= true;
         g_iFallos += 5;
    }
      if (GetAsyncKeyState(VK_F3) < 0)
    {
         // Reinicia el juego
         FJ_RecomenzarJuego(g_pJuego->ObtenerVentana());

    }
}

