//-----------------------------------------------------------------
// Aplicacin Meteoritos
// Cdigo fuente C++  - Meteoritos.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "Meteoritos.h"

//-----------------------------------------------------------------
// Funciones del juego
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo motor del juego
  // Se define un rea de juego de 400 x 200
  // y una frecuencia de 20 ciclos por segundos
  // (1 ciclo cada 50 ms)
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("Meteoritos"),
    TEXT("Meteoritos"),
    IDI_METEORITO,
    IDI_METEORITO_SM,
    400, 200, 20);

  // Si no pudo crear el objeto devuelve False
  if (g_pJuego == NULL)
    return FALSE;

  return TRUE;
}

void FJ_ComenzarJuego(HWND hVentana)
{

  // Se cuentan los ciclos
  // para poder distribuir los
  // meteoritos en la pantalla
   g_iCiclos = 0;

   // se calcula la cantidad de filas y columnas
   // sabiendo que el icono es de 32 x 32
   g_iCols = g_pJuego->ObtenerAncho()/32;
   g_iRows = g_pJuego->ObtenerAltura()/32;


}

void FJ_FinalizarJuego()
{
  // destruye el objeto ncleo motor
  delete g_pJuego;
}
void FJ_ReactivarJuego(HWND hVentana)
{
}

void FJ_DetenerJuego(HWND hVentana)
{
}

void FJ_PintarJuego(HDC hDC)
{
    // Por ahora no se implementa
    // ya que el dibujo se hace en la
    // funcin FJ_CicloJuego()
}

void FJ_CicloJuego()
{
  HDC   hDC;
  HWND  hVentana;

    // handle de la ventana
    hVentana = g_pJuego->ObtenerVentana();

    // Caen los meteoritos en sitios ordenados de la pantalla
    // Obtiene un contexto de dispositivo
    hDC = GetDC(hVentana);

    // Coloca el icono del meteorito en una posicin  calculada
    // se asignan las coordenadas x e y
    // el clculo relaciona el nmero de ciclo
    // con una posicin en la pantalla
    int y = g_iCiclos / g_iCols % g_iRows * 32;
    int x = g_iCiclos % g_iCols * 32;

    DrawIcon(hDC, x, y,
        (HICON)(WORD)GetClassLong(hVentana, GCL_HICON));

    g_iCiclos++;
    // Libera el contexto de dispositivo
    ReleaseDC(hVentana, hDC);
}

