//----------------------------------------------------------------
// Objeto cBMP
// Encabezado C++ - cBMP.h
//-----------------------------------------------------------------
#pragma once

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
// La funcin TransparentBlt requiere Winver 5
//#define WINVER 0x0500
#include <windows.h>


//-----------------------------------------------------------------
// Clase cBMP
//-----------------------------------------------------------------
class cBMP
{
protected:
  // Miembros protegidos
  HBITMAP m_hCBmp;
  BITMAPINFOHEADER m_eInfoHeader;

  // Mtodos protegidos
  void Liberar();

public:
  // Constructores
  cBMP();
   // Constructor de un bmp vaco
  cBMP(HDC hDC, SIZE sizBmp, COLORREF crColor = RGB(0, 0, 0));
  // Constructor a partir de un archivo bmp
  cBMP(HDC hDC, LPTSTR szFileName);
  // Constructor a partir de un recurso de la aplicacin
  cBMP(HDC hDC, UINT uiIDRecurso, HINSTANCE hInstance);

  // Destructor
  virtual ~cBMP();

  // Mtodos auxiliares
  // Creacin bmp vaco
  BOOL CrearBMP(HDC hDC, SIZE sizBmp, COLORREF crColor);
  // Creacin desde archivo
  BOOL CrearBMP(HDC hDC, LPTSTR szFileName);
  // Creacin desde recurso
  BOOL CrearBMP(HDC hDC, UINT uiRecursoBmp, HINSTANCE hInstancia);

  // Dibujo del bitmap
  void Dibujar(HDC hDC,
    POINT ptInicial,
    BOOL  bTransp = false,
    COLORREF crTranspColor = RGB(255, 0, 255));

  // Dibujo del bitmap
  void Dibujar(HDC hDC,
    int iX, int iY,
    BOOL  bTransp = false,
    COLORREF crTranspColor = RGB(255, 0, 255));

  // Dibujo parcial
  void DibujoParcial(HDC hDC,
    POINT ptInicial,
    POINT ptOrigen,
    SIZE  sizParcial,
    BOOL  bTransp = false,
    COLORREF crTranspColor = RGB(255, 0, 255));

  // Obtener informacin sobre el mapa de bits
  int   ObtenerAncho() { return m_eInfoHeader.biWidth; };
  int   ObtenerAltura() { return m_eInfoHeader.biHeight; };
  WORD  ObtenerProfundidad() { return m_eInfoHeader.biBitCount; };
  DWORD ObtenerImagenSize() { return m_eInfoHeader.biSizeImage; };
};

