//-----------------------------------------------------------------
// Archivo de cdigo C++ - Caracol.cpp
//-----------------------------------------------------------------
//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "Caracol.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("Caracol vs. Meteoritos"), TEXT("Caracol vs. Meteoritos"),
    IDI_CARACOL, IDI_CARACOL_SM,
    640, 480, 20); // frecuencia 20 fps equivale a 1 ciclo cada 50 milisegundos

  if (g_pJuego == NULL)
    return false;

  // Se inicializa el joystick
  if (!g_pJuego->InicializarJoystick())
    return false;

  return true;
}
void FJ_ComenzarJuego(HWND hWindow)
{
  // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);

  // el objeto impacto se mostrar cada vez que
  // se produzca una colisin
  g_pImpacto = new cBMP(hDC, TEXT("Recursos//Impacto.bmp"));

  g_pFondoJuego = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());

  // Crea un mapa de bits a partir de archivos
  // Los mapas de bits son de profundidad 24 bits
  g_pMeteorito[0] = new cBMP(hDC, TEXT("Recursos//meteorito.bmp"));
  g_pMeteorito[1] = new cBMP(hDC, TEXT("Recursos//meteorito.bmp"));
  g_pMeteorito[2] = new cBMP(hDC, TEXT("Recursos//meteorito.bmp"));
  g_pMeteorito[3] = new cBMP(hDC, TEXT("Recursos//meteorito.bmp"));
  g_pMeteorito[4] = new cBMP(hDC, TEXT("Recursos//meteorito.bmp"));


  // Caracol y caralitos de cantidad de vidas pendientes
  g_pCaracol = new cBMP(hDC, TEXT("Recursos//caracol.bmp"));
  g_pCaracolito = new cBMP(hDC, TEXT("Recursos//caracolito.bmp"));

  // Se define un rectngulo para el lmite
  // del movimiento de los sprites: toda la pantalla
  RECT rcAreaAccion = {0, 0, g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura()};

  // Definimos un hot spot menor que el
  // rectgulo del mapa de bits
  // el mapa de bits es de 50x50
  // por lo tanto, el rea sensible
  // es algo menor
  RECT rcHotSpot = {15, 15, 70, 50};

  // El caracol se detiene al llegar al lmite de la pantalla
  g_pcsCaracol = new cSprite(g_pCaracol, rcAreaAccion, AFL_DETENER);
  // Asignamos posicin
  g_pcsCaracol->AsignarPosicion(0,450);
  // Se define un rectngulo hot spot
  g_pcsCaracol->AsignarHotSpot(rcHotSpot);
  // Impacto
  g_pcsCaracol->AsignarcBmpImpacto(g_pImpacto);
  // Asigna un identificador para el caracol
  // el resto de los sprites sern 0
  g_pcsCaracol->AsignarID(1);
  // Se guarda el puntero en un vector
  g_pJuego->AgregarSprite(g_pcsCaracol);

  cSprite* pcsTemp;
  // Se aaden los meteoritos
  // Los meteoritos reaparecen de modo contnuo
  SetRect(&rcHotSpot, 10, 10, 40, 40);
  pcsTemp = new cSprite(g_pMeteorito[0], rcAreaAccion, AFL_REAPARECER);
  pcsTemp->AsignarPosicion(100,0);
  pcsTemp->AsignarVelocidad(0,6);
  pcsTemp->AsignarOrdenZ(1);
  pcsTemp->AsignarHotSpot(rcHotSpot);
  g_pJuego->AgregarSprite(pcsTemp);

  pcsTemp = new cSprite(g_pMeteorito[1], rcAreaAccion, AFL_REAPARECER);
  pcsTemp->AsignarPosicion(200,0);
  pcsTemp->AsignarVelocidad(0,5);
  pcsTemp->AsignarOrdenZ(1);
  pcsTemp->AsignarHotSpot(rcHotSpot);
  g_pJuego->AgregarSprite(pcsTemp);

  pcsTemp = new cSprite(g_pMeteorito[2], rcAreaAccion, AFL_REAPARECER);
  pcsTemp->AsignarPosicion(300,0);
  pcsTemp->AsignarVelocidad(0,15);
  pcsTemp->AsignarOrdenZ(1);
  pcsTemp->AsignarHotSpot(rcHotSpot);
  g_pJuego->AgregarSprite(pcsTemp);

  pcsTemp = new cSprite(g_pMeteorito[3], rcAreaAccion, AFL_REAPARECER);
  pcsTemp->AsignarPosicion(400,0);
  pcsTemp->AsignarVelocidad(0,8);
  pcsTemp->AsignarOrdenZ(1);
  pcsTemp->AsignarHotSpot(rcHotSpot);
  g_pJuego->AgregarSprite(pcsTemp);

  pcsTemp = new cSprite(g_pMeteorito[4], rcAreaAccion, AFL_REAPARECER);
  pcsTemp->AsignarPosicion(500,0);
  pcsTemp->AsignarVelocidad(0,9);
  pcsTemp->AsignarOrdenZ(1);
  pcsTemp->AsignarHotSpot(rcHotSpot);
  g_pJuego->AgregarSprite(pcsTemp);


  // Contamos la cantidad de ciclos
  g_iContBucle = 0;

  // Contadores del juego
  FJ_NuevoJuego();



  // Bfer auxiliar de repintado
  // Crea un contexto de dispositivo y un
  // mapa de bits adicional
  g_hBuferAuxDC = CreateCompatibleDC(hDC);
  g_hBuferAuxBitmap = CreateCompatibleBitmap(hDC,
      g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura());
  SelectObject(g_hBuferAuxDC , g_hBuferAuxBitmap);
}

void FJ_FinalizarJuego()
{
  // Elimina los elementos del bfer auxiliar
  DeleteObject(g_hBuferAuxBitmap);
  DeleteObject(g_hBuferAuxDC);

  // Elimina objetos bmp
  for (int i = 0; i < 5; i++)
    delete g_pMeteorito[i];
  delete g_pCaracol;
  delete g_pCaracolito;

  // Bitmap de impacto
  delete g_pImpacto;

  // Limpieza del vector de sprites
  g_pJuego->LimpiarVector();

  // elimina el mapa de bits de fondo
  delete g_pFondoJuego;

  // Elimina el objeto
  delete g_pJuego;
}
void FJ_ReactivarJuego(HWND hWindow)
{
    // Capturar el joystick
     g_pJuego->CapturarJoystick();
}
void FJ_DetenerJuego(HWND hWindow)
{
    // Liberar el joystick
     g_pJuego->LiberarJoystick();
}
void FJ_PintarJuego(HDC hDC)
{

    POINT ptOrigen = {0, 0};
    // El fondo del juego se pinta primero
    g_pFondoJuego->Dibujar(hDC, ptOrigen);

    // Ahora dibuja los sprites desde el vector
    // que pertenece al NucleoMotor
    g_pJuego->DibujarSprites(hDC);

    // Dibujo de las vidas pendientes
    for (int i = 0; i < g_iVidas; i++)
        g_pCaracolito->Dibujar(hDC, 0,
           g_pCaracolito->ObtenerAltura() * i + 10, true);

    TCHAR szTexto[80];
    int iPuntaje = g_iLlegadas * 100 - g_iMeteoritosCaidos;
    wsprintf(szTexto, "Puntos: %d", iPuntaje);
    TextOut(hDC, 0, 300, szTexto, strlen(szTexto));

}
void FJ_CicloJuego()
{
    if (!g_bFinJuego)
    {
        // Actualiza las posiciones de los sprites
        g_pJuego->ActualizarSprites();

        ++g_iContBucle;
        // Pintar en el contexto de dispositivo
        // auxiliar para eliminar
        // la sensacin de parpadeo
         FJ_PintarJuego(g_hBuferAuxDC);

        // Pintura real de la pantalla en una nica operacin
        HWND hVentana = g_pJuego->ObtenerVentana();
        HDC hDC = GetDC(hVentana);

        // se utilizan coordenadas 0, 0
        // porque se realiza copia completa
        // de un rea a otra
        BitBlt(hDC,
            0, 0, g_pJuego->ObtenerAncho(), g_pJuego->ObtenerAltura(),
            g_hBuferAuxDC, 0, 0,
            SRCCOPY);

        ReleaseDC(hVentana, hDC);
    }
}
void FJ_LButtonDown(LPARAM lParam)
{
   // Botn izquierdo reinicia el juego
   if (g_bFinJuego)
     FJ_NuevoJuego();
}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{

}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{
}
void FJ_CheckTeclado()
{
    // Con el teclado se regula la velocidad del caracol
    if (!g_bFinJuego && (++g_iRetenerInput >2)  )
    {
        // Las teclas de flechas sirven para indicar
        // salto hacia atrs o adelante o para
        // aumentar o reducir la velocidad

        // Obtiene estado actual
        RECT rcXY = g_pcsCaracol->ObtenerPosicion();
        POINT ptVel = g_pcsCaracol->ObtenerVelocidad();

        // Salta hacia atrs 10 pxeles
        if (GetAsyncKeyState(VK_LEFT) < 0)
            g_pcsCaracol->AsignarPosicion(rcXY.left -3, 450);

        // Aumenta la velocidad
        if (GetAsyncKeyState(VK_UP) < 0)
            g_pcsCaracol->AsignarVelocidad(ptVel.x + 1, 0);

        // Salta hacia adelante 10 pxeles
        if (GetAsyncKeyState(VK_RIGHT) < 0)
            g_pcsCaracol->AsignarPosicion(rcXY.left + 3, 450);

        // Disminuye la velocidad
        if (GetAsyncKeyState(VK_DOWN) < 0)
            g_pcsCaracol->AsignarVelocidad(ptVel.x - 1, 0);

        g_iRetenerInput = 0;
    }

    if (GetAsyncKeyState(VK_F3) < 0)
        FJ_NuevoJuego();
}

void FJ_CheckJoystick(WORD wJoyEstado)
{
    // El joystick permite una definicin de 8 direcciones en el
    // plano x y
    // con 3 botones (1, 2 y 3) se controla
    // la velocidad

    if (!g_bFinJuego && (++g_iRetenerInput > 2)  )
    {
      // Las teclas del joysticks sirven para indicar
      // salto hacia atrs o adelante o para
      // aumentar o reducir la velocidad

      // Obtiene estado actual
      RECT  rcXY = g_pcsCaracol->ObtenerPosicion();
      POINT ptVel = g_pcsCaracol->ObtenerVelocidad();
      // Verificar el movimiento vertical
      if (wJoyEstado & JARRIBA)
       g_pcsCaracol->AsignarVelocidad(ptVel.x + 1, 0);
      else if (wJoyEstado & JABAJO)
       g_pcsCaracol->AsignarVelocidad(ptVel.x - 1, 0);

      // Verifica el movimiento horizontal
      // y el combinado
      if (wJoyEstado & JIZQ)
        g_pcsCaracol->AsignarPosicion(rcXY.left -3, 450);
      if (wJoyEstado & JDER)
       g_pcsCaracol->AsignarPosicion(rcXY.left +3, 450);

      g_iRetenerInput = 0;
    }
    if (g_bFinJuego && (wJoyEstado & JBOT1))
        FJ_NuevoJuego();
}
APC_ACCION FJ_NotificarColision(TC_COLISION tcColision, cSprite* pSpriteImpactado, cSprite* pSprite)
{
  // Si el objeto impactado es el caracol
  // se pierde una vida y se recomienza
  // el juego hasta llegar
  // a la cantidad de vidas

  if ((pSprite == g_pcsCaracol) || (pSpriteImpactado == g_pcsCaracol))
 {
	  RECT rcTemp;
      switch(tcColision)
      {
        case TC_LIMITES:
        // el caracol lleg a la meta
            rcTemp = g_pcsCaracol->ObtenerPosicion();
            if (rcTemp.left > 500)
                {
                g_pcsCaracol->AsignarPosicion(0, 450);
                g_iVidas++;
                g_iLlegadas++;
            }
            break;

        case TC_SPRITE:
        // el caracol fue aplastado por un meteorito
            g_iVidas--;

            TCHAR szTexto[80];
            if (g_iVidas > 0)
            {
                wsprintf(szTexto, "1 caracol menos!, le quedan %d caracoles.", g_iVidas);
                MessageBox(g_pJuego->ObtenerVentana(), szTexto, TEXT("Caracol"), MB_OK);
            }
            else
            {
                wsprintf(szTexto, "Fin del juego! Esquiv %d meteoritos, con %d cruces", g_iMeteoritosCaidos,
                g_iLlegadas);
                MessageBox(g_pJuego->ObtenerVentana(), szTexto, TEXT("Caracol"), MB_OK);
                g_bFinJuego = true;
            }
            // Se enva al caracol a su posicin inicial
            g_pcsCaracol->AsignarPosicion(0, 450);
            break;
        }
    }
    else
    // control de lmites para los objetos meteoritos
    {
            switch (tcColision)
            {
                // contamos los meteoritos que llegan al lmite
                case TC_LIMITES:
                g_iMeteoritosCaidos++;
                // Si se llega a 100 meteoritos finaliza el juego
                if (g_iMeteoritosCaidos == 100)
                {
                    TCHAR szTexto[80];
                    wsprintf(szTexto, "Fin del juego! Se acabaron los meteoritos con %d cruces",
                        g_iLlegadas);
                    MessageBox(g_pJuego->ObtenerVentana(), szTexto, TEXT("Caracol"), MB_OK);
                    g_bFinJuego = true;
                }
                break;
                // otras opciones
                // reservamos para uso futuro
            }
    }
    return APC_NOACCION;
}


void FJ_NuevoJuego()
{
    // Funcin de limpieza de las variables
    // para reiniciar un nuevo
    g_iVidas = 3;
    g_iMeteoritosCaidos = 0;
    g_iLlegadas = 0;
    g_bFinJuego = false;
    g_pcsCaracol->AsignarPosicion(0, 450);
}
