//-----------------------------------------------------------------
// Aplicacin de prueba de la clase cBMP
// Archivo de cdigo C++ - TestcBMP.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "TestcBMP.h"

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("TestcBMP"), TEXT("TestcBMP"),
    IDI_TESTCBMP, IDI_TESTCBMP_SM,
    640, 480, 20); // frecuencia 20 fps

  if (g_pJuego == NULL)
    return FALSE;

  return TRUE;
}

void FJ_ComenzarJuego(HWND hWindow)
{
  // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);

  // distintas maneras de crear objetos cBMP
  // Crea un mapa de bits a partir de un recurso
  // Los mapas de bits son de profundidad 24 bits
  g_pBMPs[0] = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());
  g_pBMPs[1] = new cBMP(hDC, IDB_BMP2, g_pJuego->ObtenerInstancia());

  // Crea tres mapas de bits a partir de un archivo de mapa de bits
  g_pBMPs[2] = new cBMP(hDC, TEXT("Recursos//4rojo.bmp"));
  g_pBMPs[3] = new cBMP(hDC, TEXT("Recursos//4verde.bmp"));
  g_pBMPs[4] = new cBMP(hDC, TEXT("Recursos//4naranja.bmp"));

  // Crea un mapa de bits vaco con fondo de color gris
  SIZE sizBmp = {64, 120};
  g_pBMPs[5] = new cBMP(hDC, sizBmp, RGB(128, 128, 128));


  // Contamos la cantidad de ciclos
  g_iContBucle = 0;

}

void FJ_FinalizarJuego()
{

  // Limpieza de la matriz
  for (int i = 0; i < g_iCantBmp; i++)
    delete g_pBMPs[i];

  // Elimina el objeto
  delete g_pJuego;
}

void FJ_ReactivarJuego(HWND hWindow)
{
}

void FJ_DetenerJuego(HWND hWindow)
{
}

void FJ_PintarJuego(HDC hDC)
{

    // Elige la posicin del mapa de bits
    POINT ptInicio;
    ptInicio.x = (g_iContBucle * g_pBMPs[0]->ObtenerAncho()) % g_pJuego->ObtenerAncho();
    ptInicio.y = (g_iContBucle / (g_pJuego->ObtenerAncho() / g_pBMPs[0]->ObtenerAncho()) *
             g_pBMPs[0]->ObtenerAltura()) % g_pJuego->ObtenerAltura();

    POINT ptOrigen = {0,0};
    SIZE sizParcial = {32, 120};

    // decide aleatoriamente qu
    // imagen se muestra
    int i = GetTickCount() % g_iCantBmp;

    if (g_iContBucle > 39)
        return;

    // Algoritmo para repartir los 4 casos
    switch (g_iContBucle % 4){
        case 0: // parcial con transparencia
            // prueba dibujo parcial con transparencia
            // la mscara de transparencia es rojo
            g_pBMPs[i]->DibujoParcial(hDC,
               ptInicio, ptOrigen, sizParcial, TRUE, RGB(255,0,0));
            break;
        case 1: // parcial opaco
            // prueba dibujo parcial sin transparencia
            g_pBMPs[i]->DibujoParcial(hDC, ptInicio, ptOrigen, sizParcial);
            break;
        case 2: // total con transparencia
            // prueba dibujo completo con transparencia
            // la mscara de transparencia es rojo
            g_pBMPs[i]->Dibujar(hDC, ptInicio, TRUE, RGB(255, 0, 0));
            break;
        default: // total opaco
            // prueba dibujo completo sin transparencia
           g_pBMPs[i]->Dibujar(hDC, ptInicio);
    }

}

void FJ_CicloJuego()
{

    // Dibuja el juego
    // Repite el ciclo de mapas de bits
    ++g_iContBucle;
    // Invalida la ventana para forzar el repintado
    InvalidateRect(g_pJuego->ObtenerVentana(), NULL, FALSE);


}

