//-----------------------------------------------------------------
// Aplicacin de prueba del uso del ratn
// Archivo de cdigo C++ - UsoMouse.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "UsoMouse.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("UsoMouse"), TEXT("UsoMouse"),
    IDI_USOMOUSE, IDI_USOMOUSE_SM,
    600, 450, 10);

  if (g_pJuego == NULL)
    return FALSE;

  return TRUE;
}

void FJ_ComenzarJuego(HWND hWindow)
{
  // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);

  // Crea un mapa de bits a partir de un recurso
  // Los mapas de bits son de profundidad 24 bits
  g_pOvni = new cBMP(hDC, TEXT("Recursos//Ovni.bmp"));
  g_pFondoJuego = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());


 // Posicin inicial del objeto
  g_ptOvni.x = (g_pJuego->ObtenerAncho()) / 2 - (g_pOvni->ObtenerAncho() / 2);
  g_ptOvni.y = 0;

  // La direccin inicial del ovni es hacia abajo
  g_ptDireccion.x =  g_ptOvni.x;
  g_ptDireccion.y =  g_pJuego->ObtenerAltura();

  // Velocidad del Ovni
  g_iVelocidad = g_iVelocidadMax;


  // Contamos la cantidad de ciclos
  g_iContBucle = 0;

}

void FJ_FinalizarJuego()
{

  // Elimina objetos
  delete g_pOvni;
  delete g_pFondoJuego;

  // Elimina el objeto
  delete g_pJuego;
}

void FJ_ReactivarJuego(HWND hWindow)
{
}

void FJ_DetenerJuego(HWND hWindow)
{
}

void FJ_PintarJuego(HDC hDC)
{

    POINT ptOrigen = {0, 0};
    g_pFondoJuego->Dibujar(hDC, ptOrigen);;
    g_pOvni->Dibujar(hDC, g_ptOvni, TRUE, RGB(255, 0, 255));

}

void FJ_CicloJuego()
{

    // Actualiza la posicin del OVNI
    // lgebra del problema
    // actualiza la posicin x y del ovni en base
    // a la velocidad y la direccin del objeto
    //
    // Hipotenusa
    double x1 = g_ptOvni.x;
    double y1 = g_ptOvni.y;
    double x2 = g_ptDireccion.x;
    double y2 = g_ptDireccion.y;

    double h = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
    double b = x2 -x1;
    double a = y2 -y1;
    g_ptOvni.x += (g_iVelocidad * b /h);
    g_ptOvni.y += (g_iVelocidad * a /h);

    // ajuste de lmites para que el objeto no salga de la pantalla
    g_ptOvni.x = min(g_pJuego->ObtenerAncho() - g_pOvni->ObtenerAncho(), g_ptOvni.x);
    g_ptOvni.x = max(0, g_ptOvni.x);
    g_ptOvni.y = max(0, g_ptOvni.y);
    g_ptOvni.y = min(g_pJuego->ObtenerAltura() - g_pOvni->ObtenerAltura(), g_ptOvni.y);

    ++g_iContBucle;
    // Invalida la ventana para forzar el repintado
    InvalidateRect(g_pJuego->ObtenerVentana(), NULL, FALSE);

}
void FJ_LButtonDown(LPARAM lParam)
{

    POINT ptCoord = {LOWORD(lParam), HIWORD(lParam)};
    g_ptDireccion.x = ptCoord.x;
    g_ptDireccion.y = ptCoord.y;

}
void FJ_RButtonUp(LPARAM lParam)
{
}
void FJ_LButtonUp(LPARAM lParam)
{
}
void FJ_MouseMove(LPARAM lParam)
{
}
void FJ_RButtonDown(LPARAM lParam)
{

    if (g_iVelocidad > 0)
        g_iVelocidad = 0;
    else
        g_iVelocidad = g_iVelocidadMax;

}

