//-----------------------------------------------------------------
// Aplicacin de prueba de la clase CBmp
// Archivo de cdigo C++ - UsoTeclado.cpp
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Archivos de inclusin
//-----------------------------------------------------------------
#include "UsoTeclado.h"
#include <math.h>

//-----------------------------------------------------------------
// Funciones del NucleoMotor
//-----------------------------------------------------------------
BOOL FJ_InicializarJuego(HINSTANCE hInstancia)
{
  // Crea el ncleo del juego
  g_pJuego = new NucleoMotor(hInstancia,
    TEXT("UsoTeclado"), TEXT("UsoTeclado"),
    IDI_USOTECLADO, IDI_USOTECLADO_SM,
    600, 450, 10); // frecuencia 50 fps

  if (g_pJuego == NULL)
    return FALSE;

  return TRUE;
}

void FJ_ComenzarJuego(HWND hWindow)
{
  // Crea una serie de mapa de bits
  HDC hDC = GetDC(hWindow);

  // Crea un mapa de bits a partir de un recurso
  // Los mapas de bits son de profundidad 24 bits
  g_pOvni = new cBMP(hDC, TEXT("Recursos//Ovni.bmp"));
  g_pFondoJuego = new cBMP(hDC, IDB_BMP1, g_pJuego->ObtenerInstancia());


 // Posicin inicial del objeto
  g_ptOvni.x = (g_pJuego->ObtenerAncho()) / 2 - (g_pOvni->ObtenerAncho() / 2);
  g_ptOvni.y = 0;

  // La direccin inicial del ovni es hacia abajo
  g_ptDireccion.x =  g_ptOvni.x;
  g_ptDireccion.y =  g_pJuego->ObtenerAltura();

  // Velocidad del Ovni
  g_iVelocidad = g_iVelocidadMax;

  // Contamos la cantidad de ciclos
  g_iContBucle = 0;

}

void FJ_FinalizarJuego()
{

  // Elimina objetos
  delete g_pOvni;
  delete g_pFondoJuego;

  // Elimina el objeto
  delete g_pJuego;
}

void FJ_ReactivarJuego(HWND hWindow)
{
}

void FJ_DetenerJuego(HWND hWindow)
{
}

void FJ_PintarJuego(HDC hDC)
{

    POINT ptOrigen = {0, 0};
    g_pFondoJuego->Dibujar(hDC, ptOrigen);;
    g_pOvni->Dibujar(hDC, g_ptOvni, TRUE, RGB(255, 0, 255));

}

void FJ_CicloJuego()
{

    // Actualiza la posicin del OVNI
    // lgebra del problema
    // actualiza la posicin x y del ovni en base
    // a la velocidad y la direccin del objeto
    //
    // Hipotenusa = h
    double x1 = g_ptOvni.x;
    double y1 = g_ptOvni.y;
    double x2 = g_ptDireccion.x;
    double y2 = g_ptDireccion.y;

    double h = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
    double b = x2 -x1;
    double a = y2 -y1;
    g_ptOvni.x += (g_iVelocidad * b /h);
    g_ptOvni.y += (g_iVelocidad * a /h);

    // ajuste de lmites para que el objeto no salga de la pantalla
    g_ptOvni.x = min(g_pJuego->ObtenerAncho() - g_pOvni->ObtenerAncho(), g_ptOvni.x);
    g_ptOvni.x = max(0, g_ptOvni.x);
    g_ptOvni.y = max(0, g_ptOvni.y);
    g_ptOvni.y = min(g_pJuego->ObtenerAltura() - g_pOvni->ObtenerAltura(), g_ptOvni.y);

    ++g_iContBucle;
    // Invalida la ventana para forzar el repintado
    InvalidateRect(g_pJuego->ObtenerVentana(), NULL, FALSE);


}
void FJ_LButtonDown(LPARAM lParam)
{

    POINT ptCoord = {LOWORD(lParam), HIWORD(lParam)};
    g_ptDireccion.x = ptCoord.x;
    g_ptDireccion.y = ptCoord.y;

}
void FJ_RButtonUp(LPARAM lParam)
{

}
void FJ_LButtonUp(LPARAM lParam)
{

}
void FJ_MouseMove(LPARAM lParam)
{

}
void FJ_RButtonDown(LPARAM lParam)
{

    if (g_iVelocidad > 0)
        g_iVelocidad = 0;
    else
        g_iVelocidad = g_iVelocidadMax;

}

void FJ_CheckTeclado()
{
    // Se comprueba si se ha aumentado o disminuido
    // la velocidad
    // Tecla SHIFT aumenta la velocidad
    if (GetAsyncKeyState(VK_SHIFT) < 0)
        g_iVelocidad += 1;
    // Tecla CONTROL disminuye la velocidad
    if (GetAsyncKeyState(VK_CONTROL) < 0)
        g_iVelocidad -= 1;
    // Se verifica que el rango de velocidad quede
    // entre 1 y mximo
    g_iVelocidad = min(g_iVelocidad, g_iVelocidadMax);
    g_iVelocidad = max(1, g_iVelocidad);

    // Las teclas de flechas sirven para indicar direccin
    // como apoyo al uso del ratn
    // Hacia la izquierda
    if (GetAsyncKeyState(VK_LEFT) < 0) {
         g_ptDireccion.x = 0;
         g_ptDireccion.y = g_ptOvni.y;}
    // Hacia arriba
    if (GetAsyncKeyState(VK_UP) < 0) {
         g_ptDireccion.x = g_ptOvni.x;
         g_ptDireccion.y = 0;}
    // Hacia la derecha
    if (GetAsyncKeyState(VK_RIGHT) < 0)  {
         g_ptDireccion.x = g_pJuego->ObtenerAncho();
         g_ptDireccion.y = g_ptOvni.y;}
    // Hacia abajo
    if (GetAsyncKeyState(VK_DOWN) < 0)  {
         g_ptDireccion.x = g_ptOvni.x;
         g_ptDireccion.y = g_pJuego->ObtenerAltura();}


}

